//------------------print out the scale factor-------------------------;
void print_scalefac(unsigned long frameNum,int gr, int ch,side_info_type si)
{
	printf("\n----------------------SCALEFAC_BEGIN------------------\n");
	int sfb,window;
    printf("Scalefactor of frame %d granule %d channel %d is:\n",frameNum,gr,ch);
    if ((si.ch[ch].gr[gr].window_switching_flag) && (si.ch[ch].gr[gr].block_type == 2))
    {
    	if (si.ch[ch].gr[gr].mixed_block_flag)
    	{
    		for (sfb = 0; sfb < 8; sfb++)
    			printf("%d ",scalefac.ch[ch].l[sfb]);
    		for (sfb = 3; sfb < 13; sfb++)
    			for (window=0; window<3; window++)
    				printf("%d ",scalefac.ch[ch].s[window][sfb]);
    	}
    	else
    	{
			for (window=0; window<3; window++)
			{
				for(sfb=0;sfb<13;sfb++)
					printf("%d ",scalefac.ch[ch].s[window][sfb]);
				printf("\n");
			}
    	}
   }
   else
   {
	   for(sfb=0;sfb<22;sfb++)
		   printf("%d ",scalefac.ch[ch].l[sfb]);
   }
   printf("\n");
   printf("----------------------SCALEFAC_END------------------\n");
}

//------------------print out the requantization output-------------------------;
void print_requantize(unsigned long frameNum,int gr, int ch,double xr[SBLIMIT][SSLIMIT])
{
			int i,j;
			printf("\n----------------------REQUAN_BEGIN------------------\n");
        	printf("Requantization Output of frame %d granule %d, channel %d is below:\n",frameNum,gr,ch);
        	for(i=0;i<SBLIMIT;i++)
        	{
        		printf("subb%d[%d]:\t",i, i*18);
        		for(j=0;j<SSLIMIT/2;j++)
        		{
        			printf("%f\t",xr[i][j]);
        		}
        		printf("\n");
        		printf("subb%d[%d]:\t",i, i*18+9);
        		for(j=SSLIMIT/2;j<SSLIMIT;j++)
        		{
        			printf("%f\t",xr[i][j]);
        		}
        		printf("\n");
        	}
        	printf("\n");
			printf("----------------------REQUAN_END------------------\n");
}
//------------------------------print out hybird ouput---------------;
void print_hybrid_output(unsigned long frameNum,int gr, int ch,double hybridOut[SBLIMIT][SSLIMIT])
{
	int i,j;
	printf("\n----------------------HYBRID_BEGIN------------------\n");
	printf("Hybird Output of frame %d granule %d, channel %d is below:\n",frameNum, gr,ch);
	for(i=0;i<SBLIMIT;i++)
	{
		printf("subb%d[%d]:\t",i, i*18);
		for(j=0;j<SSLIMIT/2;j++)
		{
			printf("%f\t",hybridOut[i][j]);
		}
		printf("\n");
		printf("subb%d[%d]:\t",i, i*18+9);
		for(j=SSLIMIT/2;j<SSLIMIT;j++)
		{
			printf("%f\t",hybridOut[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	printf("----------------------HYBRID_END------------------\n");
}

//------------------print out the pcm sample-------------------------;
void print_pcm_sample(unsigned long frameNum,int gr,short pcm_sample[2][SSLIMIT][SBLIMIT])
{
	int i,j,k;
	printf("\n----------------------PCMSAMPLE_BEGIN------------------\n");
	for(k=0;k<2;k++)
	{
		printf("PCM Sample of frame %d granule %d, channel %d is below:\n",frameNum,gr,k);
	for(i=0;i<SSLIMIT;i++)
	{
		printf("[%d]:\t", i*32);
		for(j=0;j<SBLIMIT/2;j++)
		{
			printf("%d\t",pcm_sample[k][i][j]);
		}
		printf("\n");
		printf("[%d]:\t", i*32+16);
		for(j=SBLIMIT/2;j<SBLIMIT;j++)
		{
			printf("%d\t",pcm_sample[k][i][j]);
		}
		printf("\n");
	}
	printf("\n");
	}
	printf("\n----------------------PCMSAMPLE_END------------------\n");
}

