int pretab[22] = {0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,2,3,3,3,2,0};

void requantize
    (header_info_type *header_info,
    scalefac_type *scalefac,
    side_info_type *si,
    long int is[SBLIMIT][SSLIMIT],
    double xr[SBLIMIT][SSLIMIT],
    int gr,
    int ch)
{  // printf(" requantize entered \n");
   int i;
   i = 0;
   int ss,sb,cb=0,sfreq;
   int next_cb, cb_begin, cb_width, sign;
   struct gr_info_type *gr_info = &(si->ch[ch].gr[gr]);

   sfreq=header_info->sampling_frequency_index + (header_info->ID * 3);

   //-------------------assign scalefactor band index-----------------------;

   if (gr_info->window_switching_flag && (gr_info->block_type == 2) )
      if (gr_info->mixed_block_flag)
         next_cb = sfBandIndex[sfreq].l[1];  // mixed blocks;
      else
      {
         next_cb = sfBandIndex[sfreq].s[1]*3; // short blocks;
         cb_width = sfBandIndex[sfreq].s[1];
         cb_begin = 0;
      }
   else
      next_cb=sfBandIndex[sfreq].l[1];  // long blocks;



   for (sb=0 ; sb < SBLIMIT ; sb++)
      for (ss=0 ; ss < SSLIMIT ; ss++)
      {
    //----------------scalefactor band transition--------------------------;
          if ( (sb*SSLIMIT)+ss == next_cb)
          {
             if (gr_info->window_switching_flag && (gr_info->block_type == 2))
             {
                if (gr_info->mixed_block_flag)  // mixed blocks;
                {
                  if (((sb*SSLIMIT)+ss) == sfBandIndex[sfreq].l[8])
                  {
                     next_cb = sfBandIndex[sfreq].s[4]*3;
                     cb = 3;
                     cb_width = sfBandIndex[sfreq].s[cb+1] -
                                sfBandIndex[sfreq].s[cb];
                     cb_begin = sfBandIndex[sfreq].s[cb]*3;
                  }
                  else if (((sb*SSLIMIT)+ss) < sfBandIndex[sfreq].l[8])
                     next_cb = sfBandIndex[sfreq].l[(++cb)+1];
                  else
                  {
                     next_cb = sfBandIndex[sfreq].s[(++cb)+1]*3;
                     cb_width = sfBandIndex[sfreq].s[cb+1] -
                                    sfBandIndex[sfreq].s[cb];
                     cb_begin = sfBandIndex[sfreq].s[cb]*3;
                  }
               }
               else  // short blocks;
               {
                  next_cb = sfBandIndex[sfreq].s[(++cb)+1]*3;
                  cb_width = sfBandIndex[sfreq].s[cb+1] -
                               sfBandIndex[sfreq].s[cb];
                cb_begin = sfBandIndex[sfreq].s[cb]*3;
               }
            }
            else // long blocks;
               next_cb = sfBandIndex[sfreq].l[(++cb)+1];
         }

      //------------------compute scaling for each block-----------------------------;

         xr[sb][ss] = pow( 2.0 , (0.25 * (gr_info->global_gain - 210.0)));

         if (gr_info->window_switching_flag && (
            ((gr_info->block_type == 2) && (gr_info->mixed_block_flag == 0)) ||
            ((gr_info->block_type == 2) && gr_info->mixed_block_flag && (sb >= 2)) ))
         {  //short blocks;

            xr[sb][ss] *= pow(2.0, 0.25 * -8.0 *
                    gr_info->subblock_gain[(((sb*SSLIMIT)+ss) - cb_begin)/cb_width]);
            xr[sb][ss] *= pow(2.0, 0.25 * -2.0 * (1.0+gr_info->scalefac_scale)
                    *(scalefac->ch[ch].s[(((sb*SSLIMIT)+ss) - cb_begin)/cb_width][cb]));
         }
         else {   //long blocks;
            xr[sb][ss] *= pow(2.0, -0.5 * (1.0+gr_info->scalefac_scale)
                    * (scalefac->ch[ch].l[cb] + gr_info->preflag * pretab[cb]));
         }

         sign = (is[sb][ss]<0) ? 1 : 0;
         xr[sb][ss] *= pow( (double) abs(is[sb][ss]), ((double)4.0/3.0) );
         if (sign) xr[sb][ss] = -xr[sb][ss];
   }
}



