#include "dewindowarray.h"
#include "syn_costable.h"
#define SCALE 32768

void create_syn_filter(double filter[64][SBLIMIT])
{
    register int i,k;

    for (i=0; i<64; i++)
        for (k=0; k<32; k++){
            //if ((filter[i][k] = 1e9*cos((double)((PI/64*i+PI/4)*(2*k+1)))) >= 0)
            if ((filter[i][k] = syn_costable[32*i+k]) >= 0)
                modf(filter[i][k]+0.5, &filter[i][k]);
            else
                modf(filter[i][k]-0.5, &filter[i][k]);
            filter[i][k] *= 1e-9;
        }
}

void SubBandSynthesis
	(double *bandPtr,
	 int ch,
	 short *samples)
{
    register int i,j,k;
    register double *bufOffsetPtr, sum;
    register long foo;
    static int init = 1;
    typedef double NN[64][32];
    static NN *filter;
    typedef double BB[2][1024];
    static BB *buf;
    static int bufOffset[2] = {64,64};

    if (init) {
        buf = (BB *) malloc(sizeof(BB));
        filter = (NN *) malloc(sizeof(NN));
        create_syn_filter(*filter);
        init = 0;
    }

    bufOffset[ch] = (bufOffset[ch] - 64) & 0x3ff;
    bufOffsetPtr = &((*buf)[ch][bufOffset[ch]]);

    for (i=0; i<64; i++) {
        sum = 0;
        for (k=0; k<32; k++)
            sum += bandPtr[k] * (*filter)[i][k];
        bufOffsetPtr[i] = sum;
    }

    for (j=0; j<32; j++) {
        sum = 0;
        for (i=0; i<16; i++) {
            k = j + (i<<5);
            sum += dewindow[k] * (*buf) [ch] [( (k + ( ((i+1)>>1) <<6) ) +
                                                  bufOffset[ch]) & 0x3ff];
        }

        if(sum > 0)
        {
          foo = (long)(sum * (double) SCALE + (double)0.5);
        }
        else
        {
           foo = (long)(sum * (double)SCALE -(double)0.5);
        }

        if (foo >= (long) SCALE)      {samples[j] = (short)(SCALE-1); }
        else if (foo < (long) -SCALE) {samples[j] = (short)(-SCALE); }
        else                           samples[j] =(short)foo;
    }
}
