#include <stdio.h>
#include <stdlib.h>

#include "dataheader.h"
#include "math.h"

#define get1bit(bs) getbits(bs,1)
#define SBLIMIT 32
#define SSLIMIT 18
#define PI 3.14159265358979
unsigned int frameNum=0;//use to count the frame
    unsigned int pcm_cnt_global;
    unsigned char ss_global=0;
    unsigned char ch_global=0;
    unsigned char gr_global=0;
    short pcm_output[TESTFRAME][2][2][SSLIMIT][SBLIMIT];
//-------------------Header_Info Definition------------------;
typedef struct
{
unsigned char ID;//1 bit
unsigned char layer;//2 bit
unsigned char protection_bit;//1 bit. If it is 1, CRC check exits. CRC is 16-bit long and follows frame header.
unsigned int bitrate_index;//4 bit
unsigned int sampling_frequency_index;//2 bit
unsigned char pading_bit;//1 bit
unsigned char private_bit;//1 bit
unsigned char mode;//2 bit.00:Stero,11:Joint Stero,10 Dual Channel,01 Single Channel
unsigned char mode_extension;//2 bit
unsigned char copy_right;//1 bit
unsigned char original_home;//1 bit
unsigned char emphasis;//2 bit
unsigned int frame_length;

}header_info_type;

//--------------------Frame_Info Definition------------------;
unsigned char stereo=0;
unsigned char grNum=2;

//------------------Side_Info Definition--------------------;
typedef struct
{
	unsigned main_data_end;//9bits
	unsigned private_bits;//5bits
	struct {
	    unsigned scfsi[4];//4bits
		struct gr_info_type {
			unsigned part2_3_length;//12bits
			unsigned big_values;//9bits
			unsigned global_gain;//8bits
			unsigned scalefac_compress;//4bits
			unsigned window_switching_flag;//1bits
			unsigned block_type;//2bits
			unsigned mixed_block_flag;//1bit
			unsigned table_select[3];//5 bits each
			unsigned subblock_gain[3];//3 bits each
			unsigned region0_count;//4bits
			unsigned region1_count;//3bits
			unsigned preflag;//1bits
			unsigned scalefac_scale;//1bits
			unsigned count1table_select;//1bits
			} gr[2];
		} ch[2];
} side_info_type;

//-------------------Scalefactor Definition-------------------------;
typedef struct
{
	struct {
		int l[22];        // [cb]
		int s[3][13];     // [window][cb]
	}ch[2];				  // [ch]
} scalefac_type;

//---------------Bit Stream Definitions & Functions------------;

typedef struct  bit_stream_struc {
    unsigned char *byte_idx_ptr;   /* pointer to current byte in the arrray */
    char  bit_idx;    /* pointer to leftmost bit of current byte */
    			       /* the bit_idx for leftmost bit =7*/
} bit_stream_struc;

unsigned char mask[8]={0x1, 0x2, 0x4, 0x8, 0x10, 0x20, 0x40, 0x80};

void bs_stucture_init(bit_stream_struc *bs)
{
     bs->byte_idx_ptr=data_header;
     bs->bit_idx=7;
}

unsigned long int getbits(bit_stream_struc *bs,unsigned long n) /*read n bits*/
{
    unsigned long int val=0;
    while(n!=0)
    {
      val=((((*(bs->byte_idx_ptr))&mask[bs->bit_idx])>>bs->bit_idx)<<(n-1))|val;
      bs->bit_idx=bs->bit_idx-1;
      if(bs->bit_idx<0) {bs->bit_idx=7;bs->byte_idx_ptr++;}
      n--;
     }
    return val;
}

unsigned char bit_add(unsigned char i)
{
	i=i+1;
	if(i>1) i=0;
	return i;
}

//---------------------File Output Functions----------------------;
void SwapBytesInWords( short *loc, int words )
{
    int i;
    short thisval;
    char *dst, *src;
    src = (char *) &thisval;
    for ( i = 0; i < words; i++ )
    {
        thisval = *loc;
        dst = (char *) loc++;
        dst[0] = src[1];
        dst[1] = src[0];
    }
}

void file_output(pcm_sample,outFile,psampFrames)
short pcm_sample[2][SSLIMIT][SBLIMIT];
FILE *outFile;
unsigned long *psampFrames;
{
    int i,j,l;
    static short int outsamp[1600];
    static long k = 0;

    for (i=0;i<SSLIMIT;i++)
    	for (j=0;j<SBLIMIT;j++)
    	{
    		(*psampFrames)++;
            for (l=0;l<stereo;l++)
            {
                if (!(k%1600) && k)
                {
                	//Samples are big-endian. If this is a little-endian machine we must swap
                	SwapBytesInWords( outsamp, 1600 );
                    fwrite(outsamp,2,1600,outFile);
                    k = 0;
                }
                outsamp[k++] = pcm_sample[l][i][j];
            }
        }
}

//---------------------Tables&Preset Data------------------;

int slen[2][16] = {{0, 0, 0, 0, 3, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4},
                   {0, 1, 2, 3, 0, 1, 2, 3, 1, 2, 3, 1, 2, 3, 2, 3}};

struct  {
   int l[23];
   int s[14];
} sfBandIndex[6] =
    {{{0,6,12,18,24,30,36,44,54,66,80,96,116,140,168,200,238,284,336,396,464,522,576},
     {0,4,8,12,18,24,32,42,56,74,100,132,174,192}},
    {{0,6,12,18,24,30,36,44,54,66,80,96,114,136,162,194,232,278,330,394,464,540,576},
     {0,4,8,12,18,26,36,48,62,80,104,136,180,192}},
    {{0,6,12,18,24,30,36,44,54,66,80,96,116,140,168,200,238,284,336,396,464,522,576},
     {0,4,8,12,18,26,36,48,62,80,104,134,174,192}},

    {{0,4,8,12,16,20,24,30,36,44,52,62,74,90,110,134,162,196,238,288,342,418,576},
     {0,4,8,12,16,22,30,40,52,66,84,106,136,192}},
    {{0,4,8,12,16,20,24,30,36,42,50,60,72,88,106,128,156,190,230,276,330,384,576},
     {0,4,8,12,16,22,28,38,50,64,80,100,126,192}},
    {{0,4,8,12,16,20,24,30,36,44,54,66,82,102,126,156,194,240,296,364,448,550,576},
     {0,4,8,12,16,22,30,42,58,78,104,138,180,192}}};

//-------------------Global Data---------------------------;

bit_stream_struc main_data_beg_bs[2];
header_info_type header_info[2];//header_info[0] store the side information for previous frame.
								//header_info[1] store the side information for current frame.
side_info_type si[2];//si[0] store the side information for previous frame.
					 //si[1] store the side information for current frame.
scalefac_type scalefac;
long int is[SBLIMIT][SSLIMIT];
float xr[SBLIMIT][SSLIMIT];
float lr[2][SBLIMIT][SSLIMIT];
float ro[2][SBLIMIT][SSLIMIT];
float re[SBLIMIT][SSLIMIT];
float hybridIn[SBLIMIT][SSLIMIT];/* Hybrid filter input */
float hybridOut[SBLIMIT][SSLIMIT];/* Hybrid filter out */
float polyPhaseIn[SBLIMIT];     /* PolyPhase Input. */
short pcm_sample[2][SSLIMIT][SBLIMIT];

//typedef short PCM[2][SSLIMIT][SBLIMIT];
//PCM *pcm_sample;


